//+------------------------------------------------------------------+
//|                                                   TooAwesome.mq4 |
//|                                         Copyright  2011, dkylep |
//|                                                                  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2011, dkylep"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  White
#property  indicator_color2  Green
#property  indicator_color3  Red


#property  indicator_color4  White
#property  indicator_color5  YellowGreen
#property  indicator_color6  Magenta

#property  indicator_color7  Aqua
#property  indicator_color8  Yellow

//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];


double     ExtBuffer3[];
double     ExtBuffer4[];
double     ExtBuffer5[];
double     ExtBuffer6[];
double     ExtBuffer7[];

extern int ShortMA_1 = 5;
extern int ShortMA_2 = 34;
extern int ShortMA_3 = 100;
extern int ShortMA_4 = 1;
extern int LongMA_1 = 30;
extern int LongMA_2 = 250;
extern int LongMA_3 = 400;
extern int LongMA_4 = 40;
extern int Averaging =8;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,3);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
   
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(3,34);
   SetIndexDrawBegin(4,34);
   SetIndexDrawBegin(5,34);
   
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,242);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,241);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   
   
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   SetIndexBuffer(5,ExtBuffer5);
   SetIndexBuffer(6,ExtBuffer6);
   SetIndexBuffer(7,ExtBuffer7);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("TooAwesome v1");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| TooAwesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
double buff[100000];
double buff2[100000];
double buffAvg;
double buffAvg2;
   for(int i=0; i<limit; i++)
   {
     buff[i] =(iMA(NULL,0,ShortMA_1,0,MODE_EMA,PRICE_MEDIAN,i)-iMA(NULL,0,ShortMA_2,0,MODE_EMA,PRICE_MEDIAN,i))-(iMA(NULL,0,ShortMA_3,0,MODE_SMA,PRICE_MEDIAN,i) -iMA(NULL,0,ShortMA_4,0,MODE_SMA,PRICE_MEDIAN,i));//5,34
     buff2[i] =(iMA(NULL,0,LongMA_1,0,MODE_EMA,PRICE_MEDIAN,i)-iMA(NULL,0,LongMA_2,0,MODE_EMA,PRICE_MEDIAN,i))-(iMA(NULL,0,LongMA_3,0,MODE_SMA,PRICE_MEDIAN,i) -iMA(NULL,0,LongMA_4,0,MODE_SMA,PRICE_MEDIAN,i));//5,34
   }

   //-Average---
   for(int j=0; j<limit; j++)
   {

     buffAvg=0;
     buffAvg2=0;
     for(int k=1; k<=Averaging; k++)
     {
       buffAvg = buffAvg + buff[j+k];
       buffAvg2 = buffAvg2 + buff2[j+k];
     }
     ExtBuffer0[j] = buffAvg/Averaging;
     ExtBuffer3[j] = buffAvg2/Averaging;
    
   }
//---- dispatch values between 2 buffers for short and 2 buffers for long
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
        
      current=ExtBuffer3[i];
      prev=ExtBuffer3[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer5[i]=current;
         ExtBuffer4[i]=0.0;
        }
      else
        {
         ExtBuffer4[i]=current;
         ExtBuffer5[i]=0.0;
        }
     }
     
        
     for(i=limit-1; i>=0; i--)
     {
         if(ExtBuffer2[i+2]>0 && ExtBuffer2[i+1]<0)//if short crosses to negative
         {
            if(ExtBuffer5[i+1]>0)//if long is positive and going in negative direction
            {
               if(ExtBuffer5[i+1]>0 || ExtBuffer4[i+2]>0 || ExtBuffer4[i+3]>0 ||ExtBuffer4[i+4]>0 ||ExtBuffer4[i+5]>0 ||ExtBuffer4[i+6]>0 ||ExtBuffer4[i+7]>0||ExtBuffer4[i+8]>0 ||ExtBuffer4[i+9]>0 ||ExtBuffer4[i+10]>0)
               ExtBuffer6[i+1]=ExtBuffer5[i+1]+0.004;
            }
         }
     
         if(ExtBuffer1[i+2]<0 && ExtBuffer1[i+1]>0)//if short crosses to positive
         {
            if(ExtBuffer4[i+1]<0)//if long is positive and going in negative direction
            {
               if(ExtBuffer5[i+1]<0 || ExtBuffer5[i+2]<0 || ExtBuffer5[i+3]<0 ||ExtBuffer5[i+4]<0 ||ExtBuffer5[i+5]<0 ||ExtBuffer5[i+6]<0 ||ExtBuffer5[i+7]<0 ||ExtBuffer5[i+8]<0 ||ExtBuffer5[i+9]<0 ||ExtBuffer5[i+10]<0 )
               ExtBuffer7[i+1]=ExtBuffer4[i+1]-0.004;
            }
         }
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

